package OandA;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	
);
$VERSION = '1.02';

# methods are interspersed with POD

=head1 NAME

OandA - Perl extension for installing and operating web sites for
searching the SCA Ordinary and Armorial of heraldic data.

=head1 SYNOPSIS

  perl Makefile.PL
  config.web
  
  # on database server
  configdb

=head1 CONCEPT OF OPERATIONS

The SCA heraldic database has long been accessible through web-based
search tools. This set of modules attempts to update the code to take
advantage of the features in Perl 5.x and to generate HTML that is
valid under the version 4 specification. It also attempts to provide
documentation of the tools, including information to allow interested
parties to develop alternative search tools. In particular, there is a
need for more effective ways to search armory for conflict checking.

The tools implement a separate database server that does some preprocessing
of the armorial database to speed searches. This separation also allows
the searching to be run on a different system than the web server. It
also allows one to use other tools, including non-web based tools to
query the database. The hardened user could even telnet to the server
and issue commands directly, examining the result set directly.

To install the various static web pages and search scripts, one must
provide over a dozen chunks of data to the installation script. These
include the location of perl, local paths and URLs for the static
pages, scripts, and database file, along with where the database server
will be running. The installation writes the various pages and scripts,
and creates a database server installation script. The database server
installation script needs to be run on the system hosting that server.
In turn, the database server installation needs to know where its pieces
will be.

=head1 INSTALLATION

=head2 config.web

This is run on the system hosting the web server. It gathers information
about the environment, writes that to a configuration file, and installs
the web pages and scripts. It then writes the database server script to
be run on the system hosting the database server.

=head2 dbserver

This script is created by config.web; it gathers the environmental 
information it needs and installs the script. It does not ensure that the
category file and database file are present; that is outside the scope
of this script. dbserver offers to start the server and offers a command
line that will do the trick. 

=head1 FILES

=head2 .configweb

config.web caches the environmental information in this file. 

=head2 .configdb

dbserver caches its environmental information in this file.

=head1 FUNCTIONS

=head2 

=head1 AUTHOR

Michael Houghton, herveus@radix, known also as Herveus d'Ormonde

Copyright 2000, all rights reserved.

This may be used under the same terms as Perl itself.
Note that the actual database made available by the Society for Creative
Anachronism is not included here and is covered by different copyright
and usage terms.

=head1 SEE ALSO

L<OandA::Client> and L<OandA::Server>

=cut

1;
__END__
