package OandA::Client;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK
	$Q %substitutions
	$arm_descs $gloss_links $era $date_links $breadth $case $sort $limit
	$a $b $c $d $g $k $l $p $s $m1 $m2 $y1 $y2
	$m3 $m4 $m5 $w1 $w2 $w3 $w4 $w5 $p1 $p2 $p3 $p4 $p5
	@breadths @cases @eras @onoff
	);
use CGI;
use IO::Socket;

$CGI::DISABLE_UPLOADS = 1; # we never do uploads
$CGI::POST_MAX = 1024*1024*1024; # maximum size of a POST - 1Mb

require Exporter;

@ISA = qw(Exporter AutoLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(%substitutions
	$Q $a $b $c $d $g $k $l $p $s $m1 $m2 $y1 $y2
	$m3 $m4 $m5 $w1 $w2 $w3 $w4 $w5 $p1 $p2 $p3 $p4 $p5
	@breadths @cases @eras @onoff
	form_title init_data print_header print_trailer
	blazon make_query display_options
	connect_to_data_server
	$arm_descs $gloss_links $era $date_links
	permute
	mmap month_name kingdom_name
);
$VERSION = '0.01';
$Q = new CGI;

my $form_title = 'Untitled OandA Search Form';
$Q->default_dtd("-//W3C//DTD HTML 4.0 Transitional//EN");

@eras = qw/modern SCA/;
$era = 'modern';
@onoff = qw/enabled disabled/;
$gloss_links = 'enabled';
$arm_descs = 'disabled';
$date_links = 'enabled';
@breadths = qw/narrow broad/;
$breadth = 'narrow';
@cases = qw/case-sensitive case-insensitive/;
$case = 'case-insensitive';
$limit = '';
*a = \$arm_descs;
*b = \$breadth;
*c = \$case;
*d = \$era;
*g = \$gloss_links;
*l = \$limit;
*s = \$sort;

%substitutions = ( # get them all in one place
	'BpHintsPageUrl' => 'XXBpHintsPageUrlXX',
	'BpSearchPath' => 'XXBpSearchPathXX',
	'BpSearchUrl' => 'XXBpSearchUrlXX',
	'CloseHtml' => 'XXCloseHtmlXX',
	'CommonClientPath' => 'XXCommonClientPathXX',
	'ComplexHintsPageUrl' => 'XXComplexHintsPageUrlXX',
	'ComplexSearchPath' => 'XXComplexSearchPathXX',
	'ComplexSearchUrl' => 'XXComplexSearchUrlXX',
	'ConfigDbPath' => 'XXConfigDbPathXX',
	'CopyrightPath' => 'XXCopyrightPathXX',
	'CopyrightUrl' => 'XXCopyrightUrlXX',
	'CorrectionLogPath' => 'XXCorrectionLogPathXX',
	'CorrectionScript' => 'XXCorrectionScriptXX',
	'CorrectionUrl' => 'XXCorrectionUrlXX',
	'DataHost' => 'XXDataHostXX',
	'DataPort' => 'XXDataPortXX',
	'DateHintsPageUrl' => 'XXDateHintsPageUrlXX',
	'DateSearchPath' => 'XXDateSearchPathXX',
	'DateSearchUrl' => 'XXDateSearchUrlXX',
	'DbFormatPageUrl' => 'XXDbFormatPageUrlXX',
	'DbSymbolsPageUrl' => 'XXDbSymbolsPageUrlXX',
	'DescHintsPageUrl' => 'XXDescHintsPageUrlXX',
	'DescSearchPath' => 'XXDescSearchPathXX',
	'DescSearchUrl' => 'XXDescSearchUrlXX',
	'DocumentRoot' => 'XXDocumentRootXX',
	'DownloadPageUrl' => 'XXDownloadPageUrlXX',
	'GlossaryPath' => 'XXGlossaryPathXX',
	'GlossaryUrl' => 'XXGlossaryUrlXX',
	'Head' => 'XXHeadXX',
	'IndexDirPath' => 'XXIndexDirPathXX',
	'IndexDirUrl' => 'XXIndexDirUrlXX',
	'LimitPageUrl' => 'XXLimitPageUrlXX',
	'LoARUrl' => 'XXLoARUrlXX',
	'NameHintsPageUrl' => 'XXNameHintsPageUrlXX',
	'NameSearchPath' => 'XXNameSearchPathXX',
	'NameSearchUrl' => 'XXNameSearchUrlXX',
	'NpHintsPageUrl' => 'XXNpHintsPageUrlXX',
	'NpSearchPath' => 'XXNpSearchPathXX',
	'NpSearchUrl' => 'XXNpSearchUrlXX',
	'OverviewPageUrl' => 'XXOverviewPageUrlXX',
	'PagePath' => 'XXPagePathXX',
	'PageUrl' => 'XXPageUrlXX',
	'PerlPath' => 'XXPerlPathXX',
	'PrimerUrl' => 'XXPrimerUrlXX',
	'ScriptAlias' => 'XXScriptAliasXX',
	'ScriptPath' => 'XXScriptPathXX',
	'ScriptUrl' => 'XXScriptUrlXX',
	'SearchMenuUrl' => 'XXSearchMenuUrlXX',
	'ServerName' => 'XXServerNameXX',
	'ServerPort' => 'XXServerPortXX',
	'Trailer' => 'XXTrailerXX',
	'Trailer2' => 'XXTrailer2XX',
	'Version' => 'XXVersionXX',
	'VersionPath' => 'XXVersionPathXX',
	'VersionUrl' => 'XXVersionUrlXX',
	'WebDataPath' => 'XXWebDataPathXX',
	'WebDataUrl' => 'XXWebDataUrlXX',
	);

my %gloss = (
'Or', 'Or',
'd\'or', 'Or',
'abased', 'abased',
'addorsed', 'addorsed',
'affronty', 'affronty',
'affronte', 'affronty',
'alaunt', 'alaunt',
'annulet', 'annulet',
'annulets', 'annulet',
'antelope', 'antelope',
'appaumy', 'appaumy',
'appaume', 'appaumy',
'argent', 'argent',
'armed', 'armed',
'arrondi', 'arrondi',
'arrondy', 'arrondi',
'azure', 'azure',
'barbed', 'barbed',
'barrulet', 'barrulet',
'barrulets', 'barrulet',
'barry', 'barry',
'barruly', 'barry',
'bar', 'bar',
'bars', 'bar',
'bascinet', 'bascinet',
'bascinets', 'bascinet',
'base', 'base',
'bases', 'base',
'baton sinister', 'baton+sinister',
'batons sinister', 'baton+sinister',
'battle axe', 'battle+axe',
'battleaxe', 'battle+axe',
'beaked', 'beaked',
'bellied', 'bellied',
'bendlet', 'bendlet',
'bendlets', 'bendlet',
'bendwise sinister', 'bendwise+sinister',
'bendwise', 'bendwise',
'bendy', 'bendy',
'bend', 'bend',
'bends', 'bend',
'bezanty', 'bezanty',
'bezant', 'bezant',
'bezants', 'bezant',
'billet', 'billet',
'billets', 'billet',
'blazon', 'blazon',
'bleu celeste', 'bleu+celeste',
'bordure', 'bordure',
'bordures', 'bordure',
'brunatre', 'brunatre',
'canton', 'canton',
'cartouche', 'cartouche',
'celtic cross', 'celtic+cross',
'cendree', 'cendree',
'charged', 'charged',
'charge', 'charge',
'charges', 'charge',
'checky', 'checky',
'chequy', 'checky',
'chevron', 'chevron',
'chevrons', 'chevron',
'chief', 'chief',
'chiefs', 'chief',
'compass rose', 'compass+rose',
'compass roses', 'compass+rose',
'compass star', 'compass+star',
'compass stars', 'compass+star',
'conjoined', 'conjoined',
'contourny', 'contourny',
'contourney', 'contourny',
'cotised', 'cotised',
'counterchanged', 'counterchanged',
'counterermine', 'counterermine',
'couped', 'couped',
'courant', 'courant',
'cross', 'cross',
'crosses', 'cross',
'crux ansata', 'crux+ansata',
'cruces ansatae', 'crux+ansata',
'debruised', 'debruised',
'debruising', 'debruising',
'decrescent', 'decrescent',
'delf', 'delf',
'delfs', 'delf',
'dexter chief', 'dexter+chief',
'dexter', 'dexter',
'displayed', 'displayed',
'dovetailed', 'dovetailed',
'drakkar', 'drakkar',
'drakkars', 'drakkar',
'eclipsed', 'eclipsed',
'embattled', 'embattled',
'emblazon', 'emblazon',
'embowed', 'embowed',
'endorsed', 'endorsed',
'engrailed', 'engrailed',
'erased', 'erased',
'ermine spot', 'ermine+spot',
'ermine spots', 'ermine+spot',
'ermine tail', 'ermine+spot',
'ermine tails', 'ermine+spot',
'ermines', 'ermines',
'ermine', 'ermine',
'erminois', 'erminois',
'estencele', 'estencele',
'estoile', 'estoile',
'estoiles', 'estoile',
'fesswise', 'fesswise',
'fess', 'fess',
'fieldless', 'fieldless',
'field', 'field',
'fields', 'field',
'fimbriated', 'fimbriated',
'flaunches', 'flaunches',
'flank', 'flaunches',
'fret', 'fret',
'fructed', 'fructed',
'golpe', 'golpe',
'golpes', 'golpe',
'goute', 'goute',
'goutty', 'goutty',
'guardant', 'guardant',
'gules', 'gules',
'gunstone', 'gunstone',
'gunstones', 'gunstone',
'gyron', 'gyron',
'gyronny', 'gyronny',
'harpy', 'harpy',
'haurient', 'haurient',
'hurty', 'hurty',
'hurt', 'hurt',
'hurts', 'hurt',
'in annulo', 'in+annulo',
'in base', 'in+base',
'in bend', 'in+bend',
'in canton', 'in+canton',
'in chief', 'in+chief',
'in cross', 'in+cross',
'in fess', 'in+fess',
'in pale', 'in+pale',
'in saltire', 'in+saltire',
'increscent', 'increscent',
'indented', 'indented',
'invected', 'invected',
'inverted', 'inverted',
'issuant', 'issuant',
'label', 'label',
'latin cross', 'latin+cross',
'latin crosses', 'latin+cross',
'leaved', 'leaved',
'lion', 'lion',
'lions', 'lion',
'lozenge', 'lozenge',
'lozengy', 'lozengy',
'martlet', 'martlet',
'mascle', 'mascle',
'maunch', 'maunch',
'mound', 'mound',
'orb', 'mound',
'mount', 'mount',
'mullet', 'mullet',
'mullets', 'mullet',
'naiant', 'naiant',
'ogress', 'ogress',
'ogresses', 'ogress',
'on', 'on',
'ordinary', 'ordinary',
'ordinaries', 'ordinary',
'orle', 'orle',
'palewise', 'palewise',
'pale', 'pale',
'pales', 'pale',
'pall', 'pall',
'paly', 'paly',
'passant', 'passant',
'pean', 'pean',
'pellety', 'pellety',
'pelletty', 'pellety',
'pellet', 'pellet',
'pellets', 'pellet',
'pendant', 'pendant',
'per bend', 'per+bend',
'per chevron', 'per+chevron',
'per fess', 'per+fess',
'per pale', 'per+pale',
'per pall', 'per+pall',
'per saltire', 'per+saltire',
'pheon', 'pheon',
'pheons', 'pheon',
'pheonix', 'pheonix',
'pile', 'pile',
'piles', 'pile',
'pily', 'pily',
'pithon', 'pithon',
'jaculus', 'pithon',
'plate', 'plate',
'plates', 'plate',
'platy', 'platy',
'point', 'point',
'points', 'point',
'pomme', 'pomme',
'pommes', 'pomme',
'potent', 'potent',
'proper', 'proper',
'purpure', 'purpure',
'python', 'python',
'pythons', 'python',
'quarterly', 'quarterly',
'rampant', 'rampant',
'rayonny', 'rayonny',
'rayonne', 'rayonny',
'reguardant', 'reguardant',
'reversed', 'reversed',
'rose', 'rose',
'roses', 'rose',
'roundel', 'roundel',
'sable', 'sable',
'salient', 'salient',
'reguardant', 'reguardant',
'saltire', 'saltire',
'saltires', 'saltire',
'saltorel', 'saltorel',
'saltorels', 'saltorel',
'scarpe', 'scarpe',
'scarpes', 'scarpe',
'sejant', 'sejant',
'semy', 'semy',
'seme', 'semy',
'shield', 'shield',
'shields', 'shield',
'sinister chief', 'sinister+chief',
'sinister', 'sinister',
'slipped', 'slipped',
'sphinx', 'sphinx',
'sphinxes', 'sphinx',
'tenne', 'tenne',
'tergiant', 'tergiant',
'tierce', 'tierce',
'tincture', 'tincture',
'tinctures', 'tincture',
'tinctureless', 'tinctureless',
'torteau', 'torteau',
'torteaux', 'torteau',
'tressure', 'tressure',
'trippant', 'trippant',
'unicorn', 'unicorn',
'urdy', 'urdy',
'vair', 'vair',
'vert', 'vert',
'voided', 'voided',
'volant', 'volant',
'wavy', 'wavy',
'wyvern', 'wyvern',
'wyverns', 'wyvern',
);

my %kingdom_name = (
 'A', 'Atenveldt',
 'C', 'Caid',
 'D', 'Drachenwald',
 'E', 'the East',
 'H', 'AEthelmearc',
 'K', 'Calontir',
 'L', 'Laurel',
 'M', 'the Middle',
 'm', 'Ealdormere',
 'N', 'An Tir',
 'O', 'the Outlands',
 'Q', 'Atlantia',
 'R', 'Artemisia',
 'S', 'Meridies',
 'T', 'Trimaris',
 'W', 'the West',
 'w', 'Lochac',
 'X', 'Ansteorra');

sub kingdom_name
{
	@_ and return $kingdom_name{shift()};
	wantarray ? %kingdom_name : [%kingdom_name];
}

my %mmap = (
 'January', '01',
 'February', '02',
 'March', '03',
 'April', '04',
 'May', '05',
 'June', '06',
 'July', '07',
 'August', '08',
 'September', '09',
 'October', '10',
 'November', '11',
 'December', '12');

sub mmap { $mmap{shift()}; }

my @month_name = (
 'January',
 'February',
 'March',
 'April',
 'May',
 'June',
 'July',
 'August',
 'September',
 'October',
 'November',
 'December');

sub month_name
{
	@_ and return $month_name[shift()];
	wantarray ? @month_name : [@month_name];
}


my %type_name = (
 'a', 'augmentation',
 'b', 'badge',
 'D?','armory',
 'd', 'device',
 'g', 'regalia',
 't', 'heraldic title',
 's', 'seal',
 'N', 'name',
 'BN', 'branch name',
 'O', 'order name',
 'OC', 'order name change',
 'AN','alternate name',
 'ANC','alternate name change',
 'NC','name change',
 'Nc','name correction',
 'NC','branch-name change',
 'Nc','branch-name correction',
 'HN','household name',
 'HNC','household name change',
 'C', 'database comment',
 'j', 'joint badge reference',
 'u', 'branch designator update',
 'v', 'uncorrected variant spelling',
 'Bv', 'uncorrected variant branch-name spelling',
 'vc', 'corrected variant spelling',
 'Bvc', 'corrected variant branch-name spelling',
 'R', 'cross-reference');

=head1 NAME

OandA::Client - common client routines

=head1 SYNOPSIS

  use OandA;
  blah blah blah

=head1 DESCRIPTION

This file contains Perl routines shared between 

   XXNameSearchPathXX,
   XXDescSearchPathXX,
   XXNpSearchPathXX,
   XXBpSearchPathXX,
   XXDateSearchPathXX,
   and XXComplexSearchPathXX.
   
This should be installed at XXCommonClientPathXX on XXServerNameXX.

=head1 GLOBAL VARIABLES

=head2 $Q

$Q is the CGI object.

=head2 $p

The search string/pattern/desc.

=head1 METHODS

=head2 Database server communications

=over 4
=item connect_to_data_server

Returns a blessed object to mediate access to the data server.

=cut

sub connect_to_data_server
{
	my $sock = IO::Socket::INET->new(PeerAddr => $substitutions{DataHost},
		PeerPort => $substitutions{DataPort},
		Proto => 'tcp',
		);
	unless (defined $sock)
	{
		my $cast = "connect:$!";
		print $Q->h4("Sorry, the database server $substitutions{DataHost} refused the connection. Try again later."),
		print_trailer();
		die $cast;
	}
	my $self = {sock => $sock,
		messages => [],
		lost => [],
		matches => [],
		m => {},
		};
	bless $self, 'OandA::Client';
}

=item messages
=item lost
=item matches

Returns the member as a list or a ref to a list. 

=cut

sub messages { wantarray ? (@{shift()->{messages}}) : [@{shift()->{messages}}]; }
sub lost { wantarray ? (@{shift()->{lost}}) : [@{shift()->{lost}}]; }
sub matches { wantarray ? (@{shift()->{matches}}) : [@{shift()->{matches}}]; }

=item command(string) - send a command to the server
=item limit(number) - limit the number of items returned
=item copyright - request the copyright notice (automatic if >50 items)
=item version - get the version info
=item execute - execute the accumulated commands
=item descsearch(tolerance, operator, weight, desc list)
=item patternsearch(field, flags, operator, weight, pattern)
=item exactnamesearch(operator, weight, pattern)
=item datesearch(operator, weight, date1, date2, kingdom(s))
=item threshold(number1, number2)
=cut
sub command # send a command string to server
{
	my $S = shift->{sock};
	print $S ($_, "\015\012") foreach @_;
}

sub limit { my $self = shift; $self->command(join(" ", "l", shift)); }
sub copyright { shift->command("c"); }
sub version { shift->command("v"); }
sub execute { shift->command("EOF"); }
sub descsearch
{
	my $self = shift;
	my ($tol, $op, $wt, @descs) = @_;
	return unless @descs;
	$tol ||= '0';
	$op ||= ''; return unless $op =~ /^(|[+&])$/;
	$wt ||= '1';
	my $descs = join('|', @descs);
	$self->command("d$tol $op$wt $descs");
}
sub patternsearch
{
	my $self = shift;
	my ($field, $flags, $op, $wt, $pat) = @_;
	return unless $field =~ /^[1-5bn]$/;
	return unless defined $pat;
	$op ||= ''; return unless $op =~ /^(|[+&])$/;
	$flags ||= '';
	$wt ||= '1';
	$self->command("e$field$flags $op$wt $pat");
}
sub exactnamesearch
{
	my $self = shift;
	my ($op, $wt, $pat) = @_;
	return unless defined $pat;
	$op ||= ''; return unless $op =~ /^(|[+&])$/;
	$wt ||= '1';
	$self->command("n $op$wt $pat");
}
sub datesearch
{
	my $self = shift;
	my ($op, $wt, $d1, $d2, $k) = @_;
	$op ||= ''; return unless $op =~ /^(|[+&])$/;
	$wt ||= '1';
	return unless defined $d1;
	return unless defined $d2;
	return unless defined $k;
	$self->command("s $op$wt $d1 $d2 $k");
}
sub threshold
{
	my $self = shift;
	my $n1 = 0+shift();
	my $n2 = 0+shift();
	$self->command("t $n1 $n2");
}

=item get_matches - get the result set
=cut
sub get_matches
{
	my $self = shift;
	my $n = 0;
	my $S = $self->{sock};
	while (<$S>)
	{
		s/\015?\012$//;
		if (/^\'(.*)$/)
		{
			push @{$self->{messages}}, $1;
		}
		elsif (/^\d+\+(\d+)$/)
		{
			push @{$self->{lost}}, $_;
			$n += $1;
		}
		elsif (/^(\d+)\|/)
		{
			$self->{m}->{$1}++;
			push @{$self->{matches}}, $_;
			$n++;
		}
	}
	close $self->{sock};
	$self->{n} = $n;
	return $n;
}

=head2 Results format

<H4>No items/One item/<n> items matched <criteria> Here is one of them/Here are <n> of them.</H4>
<UL>
	<UL>
	</UL>
	<LI> name 
	<UL>
		<LI> item for name
		<LI> another item for name
	</UL>
</UL>
<H4>Here are <n> matching items/Here is one matching item with a score of <n></H4>
<UL>
	<UL>
	.
	.
	.

=item print_results - print the result set
=cut

sub print_results
{
	my $self = shift; # contains the result set
	my ($criteria, $scoresort) = @_;
	
	print $Q->h3("Results:"), "\n";
	$self->print_messages;
	
	unless ($scoresort)
	{
		print $Q->h4($self->{n} == 0 
				? 'No items' : $self->{n} == 1 
				? 'One item' : $self->{n}." items",
			" matched $criteria.",
			(@{$self->{matches}} < $self->{n}) ? (@{$self->{matches}} == 1) ? "Here's one of them." :
				join(scalar(@{$self->{matches}}), "Here are ", " of them.") : '');
	}
	
	my $prev_name = '';
	my $prev_score = 0;
	print $Q->start_ul, "\n" if $self->{n} > 0;
	foreach (@{$self->{matches}})
	{
		my ($score, @item) = split /\|/;
		if ($score =~ /^\d+$/ && $score > 0)
		{
			if ($scoresort && $score != $prev_score)
			{
				print $Q->end_ul, "\n",
					$Q->end_ul, "\n",
					$Q->h4($self->{m}->{$score} == 1 ?
						"Here is one matching item" :
						join($self->{m}->{$score}, "Here are ", " matching items"),
						"with a score of $score:"), "\n",
					$Q->start_ul, "\n";
				$prev_name = '';
				$prev_score = $score;
			}
		}
		if ($item[0] ne $prev_name)
		{
			print $Q->end_ul, "\n" unless $prev_name eq '';
			print $Q->li(name($item[0])), "\n",
				$Q->start_ul, "\n";
			$prev_name = $item[0];
		}
		$self->print_match(@item);
	}
	print $Q->end_ul x 2, "\n";
	if (@{$self->{lost}})
	{
		# summarize
		my $total_lost = 0;
		foreach (@{$self->{lost}})
		{
			if (/^(\d+)\+(\d+)$/ && $1 > 0)
			{
				$total_lost += $2;
				if ($scoresort)
				{
					$self->print_lost($1, $2, $prev_score);
					$prev_score = $1;
				}
			}
		}
		$self->print_lost('', $total_lost, '') unless $scoresort;
	}
	
	print $Q->h4("End of Results"), "\n" if $self->{n} > 0;
}
sub print_messages
{
	my $self = shift;
	print join("\n", '<PRE>', @{$self->{messages}}, '</PRE>'), "\n"
		if @{$self->{messages}};
}
sub print_lost
{
	my $self = shift;
	my ($score, $count, $lastscore) = @_;
	my $other = $lastscore eq $score ? ' other' : '';
	print  
		$Q->h4($count == 1 ? "There was one$other item" :
			"There were $count$other items",
			$score eq '' ? '' : " with a score of $score",
			$count == 1 ? " which was omitted" : " which were omitted",
			"due to the ",
			$Q->a({-href => $substitutions{LimitPageUrl}}, "limit feature"),
			"."), "\n";
}
sub print_match
{
	my $self = shift;
	my ($name, $source, $type, $text, $notes, @descs) = @_;
	my $disp = 'altered or released';
	
	if (defined($notes) && $notes =~ /^(.*)\(-([^)]+)\)(.*)/) # note beginning with '-'
	{
		$notes = $1.$3;
		$disp = $2;
	}
	my @source = split(/-/, $source);
	print $Q->start_li;
	if ($type eq 'Nc')
	{
		print "This name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was corrected to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'BNc')
	{
		print "This branch-name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was corrected to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'u')
	{
		print "This branch-name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was updated to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'ANC')
	{
		print "This alternate name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was changed to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'HNC')
	{
		print "This household name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was changed to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'OC')
	{
		print "This order name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was changed to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'BNC')
	{
		$text =~ s/^See //;
		print "This branch-name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was changed to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'NC')
	{
		$text =~ s/^See //;
		print "This name";
		print ", registered ", source($source[0]), "," if $source =~ /-/;
		print " was changed to ", name($text), " ", 
			source($source[$source =~ /-/ ? 1 : 0]), ".\n";
	}
	elsif ($type eq 'j')
	{
		print "This name was referenced ", source($source[0]),
			" as joint registrant of a badge with ", name($text), ".\n";
	}
	elsif ($type eq 'R')
	{
		$text =~ s/^See (also )?//;
		print "This name was referenced ", source($source[0]);
		if ($text =~ /^"(.+)"$/)
		{
			print "in registrations by ",
				join(" and ", map name($_), split(/" or "/, $1)), ".\n";
		}
		else
		{
			print " in a registration by ", name($text), ".\n"
		}
	}
	elsif ($type =~ /^B?vc$/)
	{
		@source = ('', $source) unless ($source =~ /-/);
		print "This appeared ", source($source[0]),
			" as a mis-spelling of ", name($text), ". ",
			"The error was corrected ", source($source[1]), ".\n";
	}
	elsif ($type =~ /^B?v$/)
	{
		print "This appeared ", source($source[0]),
			".", $Q->br, "It appears to have been a mis-spelling of ",
			name($text), ".\n";
	}
	elsif ($type eq 'BN')
	{
		print "This branch-name was registered ", source($source[0]);
		print " and released ", source($source[1]) if $source =~ /-/;
		print ".\n";
	}
	elsif ($type eq 'N')
	{
		print "This name was registered ", source($source[0]);
		print " and released ", source($source[1]) if $source =~ /-/;
		print ".\n";
	}
	elsif ($type =~ /^(t|[AH]N|O)$/)
	{
		$text =~ s/^For// if $type eq 'AN';
		print "This $type_name{$type} was registered to ",
			name($text), " ", source($source[0]);
		print " and $disp ", source($source[1]) if $source =~ /-/;
		print ".\n";
	}
	elsif ($type eq 'BD')
	{
		print "Either the branch-name or the following arms",
			" associated with it (or both) were registered ", source($source[0]);
		print " and $disp ", source($source[1]) if $source =~ /-/;
		print ".\n";
	}
	elsif ($type =~ /^[ABDS]$/)
	{
		$type = lc($type);
		print "Either the name or the following ", $type_name{$type},
			" associated with it (or both) were registered ", source($source[0]);
		print " and $disp ", source($source[1]) if $source =~ /-/;
		print ":", $Q->br, $Q->strong(blazon($text)), "\n";
	}
	elsif ($type =~ /^([abdgs]|D\?)$/)
	{
		print "The following ", $type_name{$type},
			" associated with this name was registered ", source($source[0]);
		print " and $disp ", source($source[1]) if $source =~ /-/;
		print ":", $Q->br, $Q->strong(blazon($text)), "\n";
	}
	elsif ($type eq 'C')
	{
		print "A database comment:", $Q->br, $text, "\n";
	}
	else
	{
		print "An unknown record (type = '$type') was found in the database.\n";
	}
	
	if (defined($notes) && $notes =~ s/^\((.*)\)$/1/)
	{
		foreach (split(/\)\(/, $notes))
		{
			if (/^JB: (.+)$/)
			{
				print $Q->br, "registered jointly with ", name($1), "\n";
			}
			elsif (/^-?transferred to (the )?(.+)$/)
			{
				print $Q->br, "transferred to $1", name($2), "\n";
			}
			elsif (/^For (the )?(.+)$/)
			{
				print $Q->br, "for $1", name($2), "\n";
			}
			else
			{
				print $Q->br, $Q->escapeHTML($_), "\n";
			}
		}
	}
	
	if (@descs && $arm_descs eq 'enabled')
	{
		print $Q->br, "Armory descriptions:", "\n";
		print $Q->ul($Q->li([map $Q->a({-href => make_query("DescSearch", p => $_)}, $Q->escapeHTML($_)), @descs])), "\n";
	}
}

=item sortbyblazon
=item sortbylastdate
=item sortbyname
=item sortbyscorename

These sort the result set by the specified criteria.

=cut

sub sortbyblazon
{
	my $self = shift;
	$self->{matches} = [sort byblazon @{$self->{matches}}];
}
sub sortbylastdate
{
	my $self = shift;
	$self->{matches} = [sort bylastdate @{$self->{matches}}];
}
sub sortbyname
{
	my $self = shift;
	$self->{matches} = [sort byname @{$self->{matches}}];
}
sub sortbyscorename
{
	my $self = shift;
	$self->{matches} = [sort byscorename @{$self->{matches}}];
}
sub sortbyscoreblazon
{
	my $self = shift;
	$self->{matches} = [sort byscoreblazon @{$self->{matches}}];
}
sub byblazon
{
	my (undef, undef, undef, undef, $ba) = split(/\|/, $a);
	my (undef, undef, undef, undef, $bb) = split(/\|/, $b);
	$ba cmp $bb;
}
sub bylastdate
{
	my (undef, undef, $da) = split(/\|/, $a);
	my (undef, undef, $db) = split(/\|/, $b);
	$da =~ s/^.*-//;
	$db =~ s/^.*-//;
	idate($da) <=> idate($db);
}
sub idate # convert date string to numerical month
{
	my $source = shift;
	return '' if $source eq '';
	my ($ce, $month) = unpack('A2A2', $source);
	$ce += 100 if $ce < 66; # y2k window
	$ce*12 + $month;
}
sub byname
{
	my (undef, $na) = split(/\|/, $a);
	my (undef, $nb) = split(/\|/, $b);
	$na cmp $nb;
}
sub byscorename
{
	my ($sa, $na) = split(/\|/, $a);
	my ($sb, $nb) = split(/\|/, $b);
	$sb <=> $sa || $na cmp $nb;
}
sub byscoreblazon
{
	my ($sa, undef, undef, undef, $ba) = split(/\|/, $a);
	my ($sb, undef, undef, undef, $bb) = split(/\|/, $b);
	$sb <=> $sa || $ba cmp $bb;
}

=back

=head2 HTML support

=over 4

=item form_title(title)

Sets/gets the name for the current form. 

=cut

sub form_title { @_ ? $form_title = shift : $form_title; }

=item print_header
=item print_trailer

Start and finish the page.

=cut

sub print_header
{
	print $Q->header,
		$Q->start_html(-title => $form_title,
			-author => 'herveus@radix.net',
			), "\n",
		$Q->h1(form_title), "\n", 
		$Q->start_form, "\n";
}
sub print_trailer
{
	print $substitutions{Trailer}, "\n",
		$substitutions{Trailer2}, "\n",
		$substitutions{CloseHtml}, "\n";
}

=item display_options(sort options)

Generate the 'sort items by', 'display dates in', 'glossary links',
and 'armory descriptions' popup menus. The list of sort options is
passed in; $sort contains the default sort.

=cut

sub display_options
{
	print $Q->h3("Display Options:"), "\n";
	print $Q->start_ul, "\n";
	print $Q->li("Sort items by ", 
			$Q->popup_menu(-name => 's', -default => $s, -values => [@_]),
			), "\n",
		$Q->li("Display dates in ",
			$Q->popup_menu(-name => 'd', -default => $d, -values => [@eras]),
			"style.",
			), "\n",
		$Q->li("Glossary links ", 
			$Q->popup_menu(-name => 'g', -default => $g, -values => [@onoff]),
			), "\n",
		$Q->li("Armory descriptions ", 
			$Q->popup_menu(-name => 'a', -default => $a, -values => [@onoff]),
			), "\n",
		$Q->end_ul, "\n";
}

=item permute(string)

Permute the words of a name so that the first word is significant.

=cut

sub permute
{
	local ($_) = shift;
	#print "permute($_)";
	s/^(the|la|le) +//i;
	if (/^(award|bard|barony|borough|braithrean|brotherhood|canton|casa|castle of|castrum|ch[a\342]teau|ch\{a\^\}teau|clann?|college|compagnie|companionate|company|crown principality|domus|dun|fellowship|freehold|guild|honou?r of the|house|household|hous|h[ao]?us|h\{u'\}sa|keep|kingdom|league|l'ordre|maison|office|orde[nr]|ord[eo]|ordre|principality|province|riding|shire) (.*)/i)
	{
		$_ = "$2, $1";
		$_ = "$2 $1" if /^(a[fn]|aus|d[eou]|de[ils]|dell[ao]|in|na|of?|van|vo[mn]) (.*)/i;
		$_ = "$2 $1" if /^(das|de[mn]?|der|die|el|l[ae]|les|the) (.*)/i;
	}
	#print " returned ($_)\n";
	return $_;
}

=item blazon(string)

Convert the given blazon string into HTML with links to the glossary
(if enabled).

=cut

sub blazon
{
	my @words = split(/(\W+)/, shift());
	my @out;
	for (my $i = 0; $i < @words; $i += 2)
	{
		if ($i+2 < @words) # can we get a second word?
		{
			my $Phrase = join(" ", @words[$i, $i+2]);
			my $phrase = lc($Phrase);
			if (exists $gloss{$phrase})
			{
				push @out, $Q->a({-href => make_query("Glossary", p => $gloss{$phrase})},
					$Phrase),
					$words[$i+3];
				$i+=2;
				next;
			}
		}
		
		my $phrase = $words[$i];
		$phrase = lc($phrase) unless $phrase eq 'Or';
		push @out, exists $gloss{$phrase}
			? $Q->a({-href => make_query("Glossary", p => $gloss{$phrase})}, $words[$i])
			: $words[$i];
		push @out, $words[$i+1];
	}
	return join('', @out);
}

=item name(string)

Convert the given name to a link to the corresponding name search link.

=cut

sub name
{
	my $text = shift;
	my $link = permute($text);
	$Q->a({-href => make_query("NameSearch", p => $link)}, $text);
}

=item source(string)

Format the date according to the style set in $era

=cut

sub source
{
	my $source = shift;
	return 'at some point' if !defined $source || $source eq '';
	my ($year);
	my ($ce, $month, $kingdom) = unpack('A2A2A1', $source);
	$ce += 1900; $ce += 100 if $ce < 1966;
	if ($era eq 'SCA')
	{
		$year = $ce - 1966;
		++$year if $month > 4;
		# convert numeric SCA year to Roman numerals
		$year = join("", "A.S. ",
			('', qw/X XX XXX XL L LX LXX LXXX XC/)[int($year/10)],
			('', qw/I II III IV V VI VII VIII IX/)[$year%10]);
	}
	else
	{
		$year = $ce;
	}
	my $mn = $month_name[$month];
	my $out = "in $mn of $year";
	$out .= " (via $kingdom_name{$kingdom})" if $kingdom ne '';
	return $out if $date_links eq 'disabled';
	
	my $sopt = {y1 => $ce, m1 => $mn, y2 => $ce, m2 => $mn};
	if ($kingdom ne '')
	{
		push @{$sopt->{k}}, $kingdom;
	}
	else
	{
		push @{$sopt->{k}}, sort keys %kingdom_name; 
	}
	return $Q->a({-href => make_query("DateSearch", $sopt)}, $out);
}

=item make_query(query, params)

Construct a URL with query string. The 'query' parameter identifies the
search, taken from the following values:

   BpSearch - Blazon Pattern Search
   ComplexSearch - Complex Search
   DateSearch - Date/Kingdom Search
   DescSearch - Armory Description Search
   NameSearch - Exact Name Search
   NpSearch - Name Pattern Search
   Glossary - Glossary Lookup

The remainder of the paramter list is either a reference to a hash or
parameter-name/value pairs.

=cut

sub make_query
{
	my $query = $substitutions{shift().'Url'} or return '';
	my $parms = ref($_[0]) ? shift : {@_};
	return $query . '?' . CGI->new($parms)->query_string;
}

=back

=head2 Form data access

=over 4
=item init_data(list)

Parses the QUERY string and populates the global variables $p, etc.


=cut

sub init_data
{
	my %vars = map { $_, 1 } @_;
	foreach ($Q->param())
	{
		next unless $vars{$_}; # skip unwanted items
		no strict 'refs';
		${$_} = $Q->param($_);
	}
}

=back

=head1 AUTHOR

Michael Houghton, herveus@radix.net
Copyright 2000-2001, Michael Houghton, all rights reserved.
This code may be used under the same terms as Perl itself.

Based on work by Stephen Gold.

=head1 SEE ALSO

perl(1).

=cut

1;
__END__
